using System;
using System.Collections.Generic;
using ReactiveUI;
using Captchapp.Models;
using Avalonia.Controls.Shapes;
using Avalonia.Controls;
using Avalonia.Media;
using DynamicData.Diagnostics;

namespace Captchapp.ViewModels
{
	public class Page2ViewModel : ReactiveObject
	{
		private int selectedIndex = 0;
        string[] operators = ["+", "-", "*", "/"];
        private string operatorText = "+";
        private string firstOperand = "";
        private string secondOperand = "";
        private string result = "";

        public string OperatorText {
            get => operatorText;
            set => this.RaiseAndSetIfChanged(ref operatorText, value);
        }

        public string FirstOperand
        {
            get => firstOperand;
            set => this.RaiseAndSetIfChanged(ref firstOperand, value);
        }

        public string SecondOperand
        {
            get => secondOperand;
            set => this.RaiseAndSetIfChanged(ref secondOperand, value);
        }

        public string Result
        {
            get => result;
            set => this.RaiseAndSetIfChanged(ref result, value);
        }

        public int SelectedIndex {
            get => selectedIndex;
            set {
                this.RaiseAndSetIfChanged(ref selectedIndex, value);
                OperatorText = operators[selectedIndex];
            }
        }
        public void Calculate()
        {
            double a, b;
            switch (selectedIndex) {
                case 0:
                    if (Double.TryParse(FirstOperand, out a) & Double.TryParse(SecondOperand, out b))
                        Result = Convert.ToString(Convert.ToDouble(FirstOperand) + Convert.ToDouble(SecondOperand));       
                    break;
                case 1:
                    if (Double.TryParse(FirstOperand, out a) & Double.TryParse(SecondOperand, out b))
                        Result = Convert.ToString(Convert.ToDouble(FirstOperand) - Convert.ToDouble(SecondOperand));
                    break;
                case 2:
                    if (Double.TryParse(FirstOperand, out a) & Double.TryParse(SecondOperand, out b))
                        Result = Convert.ToString(Convert.ToDouble(FirstOperand) * Convert.ToDouble(SecondOperand));
                    break;
                case 3:
                    if (Double.TryParse(FirstOperand, out a) & Double.TryParse(SecondOperand, out b) & b != 0)
                        Result = Convert.ToString(Convert.ToDouble(FirstOperand) / Convert.ToDouble(SecondOperand));
                    break;
            }

        }


    }

    

}